/* This piece watches an RSS feed from CNN and every 30 seconds looks at the key words from a predetermined
list and displays how often they appear.  Each sucessive appearance becomes less transparent and more red.*/


String URL = "http://topics.cnn.com/topics/feeds/rss/politics";   //our rss feed
PFont font;
float tempnum = 0;
int y = 0;
String[] data;
String[] words;


//load up our font, also notice the framerate is about every 30sec.
void setup(){
  font = loadFont("Arial-Black-48.vlw");
  smooth();
  size(410,400);
  frameRate(.03);
}

void draw(){
  data = loadStrings(URL);      //load the website into the string called "data"
  y = 0;         //reset the location for the series of words
  background(255);   
   textFont(font, 20);   //set the text size for the following calls of the function "wordchecker"
wordchecker("Iraq");       //call wordchecker and have it look for "Iraq"
wordchecker("Iran");
wordchecker("Bush");
wordchecker("Cheney");
wordchecker("war");
wordchecker("nuclear");
wordchecker("China");
wordchecker("Turkey");
wordchecker("Pakistan");
wordchecker("Democrat");
wordchecker("Republican");
wordchecker("Clinton");
wordchecker("Obama");
wordchecker("Edwards");
wordchecker("Giuliani");
wordchecker("Romney");
wordchecker("Thompson");
wordchecker("McCain");
fill(240, 5, 5);
rect(0, height - 40, width, height);   //make a rect for the footer
fill(0);
 textFont(font, 48);
text("Politics on CNN", 0, height);   //label the footer


}

void wordchecker(String word1) {   //this custom function goes thru the whole text and finds the word sent to it
  tempnum = 0;  //for each word, reset this variable which determines x location and transparency and redness
  y += 20;  //each time wordchecker is called, increase y so succesive calls do not overlap
   fill(0);
  text(word1, 0, y);  //print the word in black so you know what is being looked for
   for (int i=0; i<data.length; i++){   //goes through each line
    String separators = WHITESPACE + "/<>*_;:?()\"-";    //these are the items we want to seperate words by and disclude from our final words
    words = splitTokens(data[i], separators);    ///breaks each line into words
    for(int j=0; j<words.length; j++){   //goes thru each word
      if(words[j].startsWith(word1)) {   //if it finds the specific word we are looking for, write it, and each time we write it, increase redness and opacity
        fill(tempnum *8, 0, 0, (tempnum * 5)+ 20);
        text(word1, (tempnum * 10) + 10, y);
        tempnum++;
        //println(tempnum);
      }
    }
   }
}
  
  
